/*
 * @Description:
 * @Version: 1.0
 * @Autor: zhuyijun
 * @Date: 2021-12-21 11:10:36
 * @LastEditTime: 2021-12-21 13:18:52
 */
#include <bits/stdc++.h>
using namespace std;

//超时
// int findRadius(vector<int>& houses, vector<int>& heaters) {
//   int res = 0;
//   vector<int> list;
//   for (vector<int>::iterator i = houses.begin(); i < houses.end(); i++) {
//     for (vector<int>::iterator j = heaters.begin(); j < heaters.end(); j++) {
//       int temp = *i > *j ? *i - *j : *j - *i;
//       list.push_back(temp);
//     }
//     auto p = min_element(list.begin(), list.end());
//     int temp = list[p - list.begin()];
//     res = temp > res ? temp : res;
//     list.clear();
//   }
//   return res;
// }

// 通过
int findRadius(vector<int>& houses, vector<int>& heaters) {
  int res = 0;
  vector<int> list;
  sort(heaters.begin(), heaters.end());
  for (vector<int>::iterator i = houses.begin(); i < houses.end(); i++) {
    int j = upper_bound(heaters.begin(), heaters.end(), *i) - heaters.begin();
    int m = j - 1;
    int rightDistance = j >= heaters.size() ? INT_MAX : heaters[j] - *i;
    int leftDistance = m < 0 ? INT_MAX : *i - heaters[m];
    int curDistance = min(leftDistance, rightDistance);
    res = max(res, curDistance);
  }
  return res;
}

//通过
// int findRadius(vector<int> &houses, vector<int> &heaters) {
//   int ans = 0;
//   sort(heaters.begin(), heaters.end());
//   for (int house : houses) {
//     int j =
//         upper_bound(heaters.begin(), heaters.end(), house) - heaters.begin();
//     int i = j - 1;
//     int rightDistance = j >= heaters.size() ? INT_MAX : heaters[j] - house;
//     int leftDistance = i < 0 ? INT_MAX : house - heaters[i];
//     int curDistance = min(leftDistance, rightDistance);
//     ans = max(ans, curDistance);
//   }
//   return ans;
// }
int main() {
  vector<int> li = {1, 2, 3};
  vector<int> re = {2};
  cout << findRadius(li, re);
  return 0;
}