/*
 * @Description:
 * @Version: 1.0
 * @Autor: zhuyijun
 * @Date: 2021-12-22 09:55:23
 * @LastEditTime: 2021-12-22 13:10:24
 */

/*
686. 重复叠加字符串匹配

给定两个字符串 a 和 b，寻找重复叠加字符串 a 的最小次数，使得字符串 b
成为叠加后的字符串 a 的子串，如果不存在则返回 -1。

注意：字符串 "abc" 重复叠加 0 次是 ""，重复叠加 1 次是 "abc"，重复叠加 2 次是
"abcabc"。
示例 1：

输入：a = "abcd", b = "cdabcdab"
输出：3
解释：a 重复叠加三遍后为 "abcdabcdabcd", 此时 b 是其子串。

示例 2：

输入：a = "a", b = "aa"
输出：2

*/
#include <bits/stdc++.h>
using namespace std;
int repeatedStringMatch(string a, string b) {
  string tempA = a;
  // cnt代表的A重复的次数,midRepCnt代表的B串中间A重复的次数
  int cnt = 1, Asize = a.size(), Bsize = b.size(), midRepCnt = Bsize / Asize;
  // midRepCnt代表的B串中间A重复的次数,2是首位各添加一个A串
  while (cnt <= midRepCnt + 2) {
    if (tempA.find(b) != string::npos) {
      return cnt;
    }
    tempA += a;  //重复次数自增
    cnt += 1;
  }
  return -1;
}

int main() { return 0; }