/*
 * @Description:
 * @Version: 1.0
 * @Autor: zhuyijun
 * @Date: 2021-11-17 09:36:34
 * @LastEditTime: 2021-11-17 09:48:24
 */
#include <iostream>
#include <string>

#include "redis_handler.h"
using namespace std;

int main() {
  RedisHandler* rh = new RedisHandler();
  int ret;
  ret = rh->connect("127.0.0.1", 6379, "");
  if (ret != M_REDIS_OK) cout << "redis error: " << rh->getErrorMsg() << endl;

  ret = rh->setValue("key11", "value11");
  if (ret != M_REDIS_OK) {
    cout << "redis error: " << rh->getErrorMsg() << endl;
    return ret;
  }
  string str;
  // get测试
  ret = rh->getValue("key11", str);
  if (ret != M_REDIS_OK) {
    cout << "redis error: " << rh->getErrorMsg() << endl;
    return ret;
  } else
    cout << "value : " << str << endl;

  // print测试
  ret = rh->printAll();
  if (ret != M_REDIS_OK) {
    cout << "redis error: " << rh->getErrorMsg() << endl;
    return ret;
  }
  ret = rh->delKey("key11");
  if (ret != M_REDIS_OK) {
    cout << "redis error: " << rh->getErrorMsg() << endl;
    return ret;
  }

  delete rh;

  return 0;
}
